Subject: [PATCH] doc: option value may be separate for valid reasons

From: Junio C Hamano <[email-masked]>
Date: Sun, 24 Nov 2024 18:43:55 +0900

Even though `git help cli` recommends users to prefer using
"--option=value" over "--option value", there can be reasons why
giving them separately is a good idea.  One reason is that shells do
not perform tilde expansion for `--option=~/path/name` but they
expand `--options ~/path/name` just fine.

This is not a problem for many options whose option parsing is
properly written using OPT_FILENAME(), because the value given to
OPT_FILENAME() is tilde-expanded internally by us, but some commands
take a pathname as a mere string, which needs this trick to have the
shell help us.

I think the reason we originally decided to recommend the stuck form
was because an option that takes an optional value requires you to
use it in the stuck form, and it is one less thing for users to
worry about if they get into the habit to always use the stuck form.
But we should be discouraging ourselves from adding an option with
an optional value in the first place, and we might want to weaken
the current recommendation.

In any case, let's describe this one case where it is necessary to
use the separate form, with an example.

Signed-off-by: Junio C Hamano <[email-masked]>
---
 Documentation/gitcli.txt         | 10 ++++++++++
 Documentation/gitcredentials.txt |  5 +++++
 2 files changed, 15 insertions(+)

diff --git c/Documentation/gitcli.txt w/Documentation/gitcli.txt
index 7c709324ba..e484be9a36 100644
--- c/Documentation/gitcli.txt
+++ w/Documentation/gitcli.txt
@@ -88,10 +88,20 @@ scripting Git:
    other words, write `git foo -oArg` instead of `git foo -o Arg` for short
    options, and `git foo --long-opt=Arg` instead of `git foo --long-opt Arg`
    for long options.  An option that takes optional option-argument must be
    written in the 'stuck' form.
 
+ * Despite the above suggestion, when Arg is a path relative to the
+   home directory of a user, e.g. ~/directory/file or ~u/d/f, you
+   may want to use the separate form, e.g. `git credential-store
+   --file ~/sec/rit`, not `git credential-store --file=~/sec/rit`.
+   The shell will expand `~/` in the former to your home directory,
+   but most shells keep the tilde in the latter.  Some of our
+   commands know how to tilde-expand the option value internally,
+   but not all.  The `--file` option of `credential-store` is an
+   example that it needs shell's help to tilde-expand its value.
+
  * When you give a revision parameter to a command, make sure the parameter is
    not ambiguous with a name of a file in the work tree.  E.g. do not write
    `git log -1 HEAD` but write `git log -1 HEAD --`; the former will not work
    if you happen to have a file called `HEAD` in the work tree.
 
diff --git c/Documentation/gitcredentials.txt w/Documentation/gitcredentials.txt
index 71dd19731a..f6ce923f25 100644
--- c/Documentation/gitcredentials.txt
+++ w/Documentation/gitcredentials.txt
@@ -240,10 +240,15 @@ Here are some example specifications:
 # the arguments are parsed by the shell, so use shell
 # quoting if necessary
 [credential]
 	helper = "foo --bar='whitespace arg'"
 
+# store helper (discouraged) with custom location for the db file;
+# tilde expansion often requires the filename as a separate argument.
+[credential]
+	helper = "store --file ~/.git-secret.txt"
+
 # you can also use an absolute path, which will not use the git wrapper
 [credential]
 	helper = "/path/to/my/helper --with-arguments"
 
 # or you can specify your own shell snippet